from xml.dom.minidom import parse
from xml.dom import EMPTY_NAMESPACE

import xml.dom.minidom
#import sys

rouge = '#ff0000'


class neudXML(xml.dom.minidom.Element):

	def __init__(self,nom,text=" ",fils=None):
		xml.dom.minidom.Element.__init__(self,nom)

		# Ajouter un noeud texte
		noeudtexte = xml.dom.minidom.Text()
		noeudtexte.replaceWholeText(text)
		self.appendChild(noeudtexte)

		#Ajouter tous les fils
		if fils:
			for f in fils:
				self.appendChild(f)

class ligne:
	def __init__(self,xy1,xy2):
		self.xy1=xy1
		self.xy2=xy2
		self.epaisseur=5
		self.couleur="#000000"




class emplacement:
	def __init__(self,position,couleur):
		self.position=position
		self.couleur=couleur
		self.rayonCourone=68
		self.rayonCentre=23
		
class balle:
	rayon=23
	def __init__(self,position,couleur):
		self.position=position
		self.couleur=couleur
		self.rayon=23		
		
class totem:
	rayonCourone=40
	rayonCentre=26	
	def __init__(self,position1,position2):
		self.position1=position1
		self.position2=position2
		self.couleur="white"




class terrain :
	def __init__(self,fichier):
		self.taille=[0,0]
		self.couleur="#00A200"
		self.emplacements=[]
		self.lignes=[]
		self.balles=[]
		self.totems=[]
		self.fichier=fichier
		
	def lectureBDD(self) :
		self.emplacements=[] ## on efface avant de faire une (re)lecture
		self.lignes=[]
		BDD = parse(self.fichier)
		terrains = BDD.documentElement.getElementsByTagName('terrain')
		
		for t in terrains :
			self.taille=(  int( t.attributes["taillex"].value ) , int( t.attributes["tailley"].value )  )
			
			lignes =  t.getElementsByTagName('ligne')
			
			for l in lignes:
				self.lignes.append(   ligne(  ( int( l.attributes["x1"].value ) , int( l.attributes["y1"].value )  ) , (  int( l.attributes["x2"].value ) , int( l.attributes["y2"].value )  )   )    )
			
			emplacements = t.getElementsByTagName('emplacement')
			for e in emplacements:
				self.emplacements.append( emplacement(  ( int( e.attributes["x"].value ) , int( e.attributes["y"].value ) ) , rouge))

			balles = t.getElementsByTagName('balle')
			for e in balles:
				self.balles.append( balle(  ( int( e.attributes["x"].value ) , int( e.attributes["y"].value ) ) , e.attributes["couleur"].value))

			totems = t.getElementsByTagName('totem')
			for e in totems:
				self.totems.append( totem(  ( int( e.attributes["x1"].value ) , int( e.attributes["y1"].value ) ) ,( int( e.attributes["x2"].value ) , int( e.attributes["y2"].value ) ) ))



	def getText(self, node):
		return node.childNodes[0].nodeValue.strip('\t\n')
	

