############ fenetre principal ##############
import math
from Tkinter import *
from tkMessageBox import *
import tkFileDialog
import bdd
import Image
import ImageTk
import trajectoire

vert="#00a200"
rouge="#ff0000"
bleu="#0000ff"
noir="#000000"

ratio=4



import threading
import thread
import time
from threading import *

pause = Event()
pause.set()


class temps(threading.Thread):
	
	def __init__(self,root):
		self.root=root
		threading.Thread.__init__(self)
	
	def run(self):
		
		self.root.positionDepart()
		self.root.listeAction.delete(0, END)
		for p in self.root.trajectoire.points:
			
			orientationSuivante=(-1)*math.atan2(p.position[1] - self.root.Robot.position[1],p.position[0] - self.root.Robot.position[0])*180/math.pi
			int
			distance=math.pow((p.position[1] - self.root.Robot.position[1]),2)
			distance+=math.pow((p.position[0] - self.root.Robot.position[0]),2)
			distance=math.sqrt(distance)
			
			self.root.listeAction.insert(END,"virage("+str(int(orientationSuivante))+");")
			self.root.listeAction.insert(END,"avance("+str(int(distance))+");")
			
			
			delta=orientationSuivante-self.root.Robot.orientation
			while math.fabs(delta) > 5:
				delta=orientationSuivante-self.root.Robot.orientation
				
				if delta < -180 :
					delta += 360
				if delta > 180 :
					delta -= 360
				
				if delta > 0 :
					self.root.leftTouch(self)
					time.sleep(1/self.root.Robot.vitesse)
				if delta < 0 :
					self.root.rightTouch(self)	
					time.sleep(1.0/self.root.Robot.vitesse)
					
			self.root.Robot.orientation=orientationSuivante
			
			while math.fabs(p.position[0]-self.root.Robot.position[0])>20 or math.fabs(p.position[1]- self.root.Robot.position[1])>20 :
				
				self.root.upTouch(self)
				time.sleep(1/self.root.Robot.vitesse)
			self.root.Robot.position[0]=p.position[0]
			self.root.Robot.position[1]=p.position[1]
		
		self.root.activation()

class acceleration(threading.Thread):
	
	def __init__(self,root):
		self.root=root
		threading.Thread.__init__(self)
	
	def run(self):
		
		pass



class MainWindow :
	def __init__(self,master,Terrain,Robot):
		self.Terrain=Terrain
		self.master=master
		self.Robot=Robot
		self.tempsActif=False
###################  Frame principal #################################
		self.frame = Frame(self.master,width=1024,height=768, bd=1)

		self.frameParametre = Frame(self.frame, bd=2,relief = "groove")			
	
		self.scaleTotem = Scale(self.frameParametre,orient=HORIZONTAL,width=20,length=100,label="position totem",from_=1,to=4,command=self.updateTotem)
		self.scaleTotem.pack(side=LEFT)
		
		self.scaleVitesse = Scale(self.frameParametre,orient=HORIZONTAL,width=20,length=100,label="Vitesse",from_=1,to=50,command=self.updateVitesse)
		self.scaleVitesse.pack(side=RIGHT)
		self.scaleVitesse.set(self.Robot.vitesse)	
		
		self.boutonRetourAuDepart = Button(self.frameParametre,text="Retour au depart", command=self.positionDepart)
		self.boutonRetourAuDepart.pack(side=BOTTOM, padx=5)
		
		self.frameParametre.pack(expand=1, fill=X, pady=10, padx=5)

		
		self.frameTerrain = Frame(self.frame, bd=2,relief = "groove")			
		self.canvasTerrain= Canvas(self.frameTerrain,height = Terrain.taille[1]/ratio, width= Terrain.taille[0]/ratio, background=Terrain.couleur)
		
		self.scrollbarAction = Scrollbar(self.frameTerrain, orient=VERTICAL)
		self.listeAction=Listbox(self.frameTerrain,height=37,yscrollcommand=self.scrollbarAction.set,background="#ffffff")
		

		self.scrollbarAction.config(command=self.listeAction.yview)
		self.scrollbarAction.pack(side=RIGHT, fill=Y)	
		self.listeAction.pack(side=RIGHT)		
		self.canvasTerrain.pack(side=LEFT)
		
		
		self.frameTerrain.pack(expand=1)
		
		
		for e in Terrain.emplacements:
			## trace des cercle de couleurs
			pos=((e.position[0]-e.rayonCourone)/ratio,(e.position[1]-e.rayonCourone)/ratio,(e.position[0]+e.rayonCourone)/ratio,(e.position[1]+e.rayonCourone)/ratio)
			self.canvasTerrain.create_oval( pos , fill="red",tags="trousRouge")
			
			pos=( (Terrain.taille[0]- (e.position[0]-e.rayonCourone))/ratio,(e.position[1]-e.rayonCourone)/ratio,(Terrain.taille[0]- (e.position[0]+e.rayonCourone))/ratio,(e.position[1]+e.rayonCourone)/ratio)
			self.canvasTerrain.create_oval( pos , fill="blue",tags="trousBleu")
			## trace des trous

			pos=((e.position[0]-e.rayonCentre)/ratio,(e.position[1]-e.rayonCentre)/ratio,(e.position[0]+e.rayonCentre)/ratio,(e.position[1]+e.rayonCentre)/ratio)
			self.canvasTerrain.create_oval( pos , fill="white",tags="trousRouge")
			
			pos=( (Terrain.taille[0]- (e.position[0]-e.rayonCentre))/ratio,(e.position[1]-e.rayonCentre)/ratio,(Terrain.taille[0]- (e.position[0]+e.rayonCentre))/ratio,(e.position[1]+e.rayonCentre)/ratio)
			self.canvasTerrain.create_oval( pos , fill="white",tags="trousBleu")
			
		for l in Terrain.lignes:
			## trace des lignes
			self.canvasTerrain.create_line(l.xy1[0]/ratio,l.xy1[1]/ratio,l.xy2[0]/ratio,l.xy2[1]/ratio,tags="ligne")
			
		for b in Terrain.balles:
			## trace des balles
			pos=((b.position[0]-b.rayon)/ratio,(b.position[1]-b.rayon)/ratio,(b.position[0]+b.rayon)/ratio,(b.position[1]+b.rayon)/ratio)
			self.canvasTerrain.create_oval( pos , fill=b.couleur,tags="balle")
		
			
		
		
		self.canvasTerrain.image=ImageTk.PhotoImage(self.Robot.img)
		
		
		self.canvasRobot=self.canvasTerrain.create_image(self.Robot.position[0]/ratio,self.Robot.position[1]/ratio,image=self.canvasTerrain.image)
		

		
		self.frameInterface = Frame(self.frame, bd=2,relief = "groove")			
		self.boutonNewTrajectoire = Button(self.frameInterface,text="Nouvelle trajectoire", command=self.newTrajectoire)
		self.boutonNewTrajectoire.pack(side=LEFT, padx=5)
		self.ActionEnCours = StringVar()
		self.labelActionEnCours = Label(self.frameInterface,textvariable=self.ActionEnCours)
		self.labelActionEnCours.pack()
		self.activerPilotage()
		self.frameInterface.pack(expand=1, fill=X, pady=10, padx=5)

		self.frameTrajectoire = Frame(self.frame, bd=2,relief = "groove")			
		self.boutonRunTrajectoire = Button(self.frameTrajectoire,text="Lancer trajectoire", command=self.runTrajectoire)
		self.boutonRunTrajectoire.pack(side=LEFT, padx=5)
		
		self.boutonPauseTrajectoire = Button(self.frameTrajectoire,text="Pause/Play", command=self.pauseTrajectoire)
		self.boutonPauseTrajectoire.pack(side=LEFT, padx=5)
		self.frameTrajectoire.pack(expand=1, fill=X, pady=10, padx=5)

	

		self.frame.pack()
	
#######################  Methodes ####################################################	

	def pauseTrajectoire(self):
		if pause.isSet():
			pause.clear()
		else:
			pause.set()
		

	def positionDepart(self):
		self.Robot.position[0] = self.Robot.positionInitial[0]
		self.Robot.position[1] = self.Robot.positionInitial[1]
		self.Robot.orientation=0
		self.updateRobot()
		
	
	def updateTotem(self,event):
		self.canvasTerrain.delete("totemBlue","totemRed","balleMobile")
		
		if self.scaleTotem.get() == 1:
			self.traceTotem(self.Terrain.totems[0].position1)
			self.traceTotem(self.Terrain.totems[1].position1)
			self.traceBalle(self.Terrain.totems[0].position2)
			self.traceBalle(self.Terrain.totems[1].position2)
		elif self.scaleTotem.get() == 2:
			self.traceTotem(self.Terrain.totems[0].position1)
			self.traceTotem(self.Terrain.totems[1].position2)
			self.traceBalle(self.Terrain.totems[0].position2)
			self.traceBalle(self.Terrain.totems[1].position1)
		elif self.scaleTotem.get() == 3:
			self.traceTotem(self.Terrain.totems[0].position2)
			self.traceTotem(self.Terrain.totems[1].position1)
			self.traceBalle(self.Terrain.totems[0].position1)
			self.traceBalle(self.Terrain.totems[1].position2)
		elif self.scaleTotem.get() == 4:
			self.traceTotem(self.Terrain.totems[0].position2)
			self.traceTotem(self.Terrain.totems[1].position2)
			self.traceBalle(self.Terrain.totems[0].position1)
			self.traceBalle(self.Terrain.totems[1].position1)
			
	def symetrie(self,pos):
		pos[0]=self.Terrain.taille[0]/ratio - pos[0]
		pos[1]=self.Terrain.taille[1]/ratio - pos[1]
				
		pos[2]=self.Terrain.taille[0]/ratio - pos[2]
		pos[3]=self.Terrain.taille[1]/ratio - pos[3]
		return pos
	
	def traceBalle(self,position):
		pos=[(position[0]-bdd.balle.rayon)/ratio,(position[1]-bdd.balle.rayon)/ratio,(position[0]+bdd.balle.rayon)/ratio,(position[1]+bdd.balle.rayon)/ratio]
		self.canvasTerrain.create_oval( pos , fill="white",tags="balleMobile")
		pos=self.symetrie(pos)
		self.canvasTerrain.create_oval( pos , fill="white",tags="balleMobile")

	def traceTotem(self,position):
		pos=[(position[0]-bdd.totem.rayonCourone)/ratio,(position[1]-bdd.totem.rayonCourone)/ratio,(position[0]+bdd.totem.rayonCourone)/ratio,(position[1]+bdd.totem.rayonCourone)/ratio]
		self.canvasTerrain.create_oval( pos , fill="blue",tags="totemBlue")
		pos=self.symetrie(pos)
		self.canvasTerrain.create_oval( pos , fill="red",tags="totemRed")

		pos=[(position[0]-bdd.totem.rayonCentre)/ratio,(position[1]-bdd.totem.rayonCentre)/ratio,(position[0]+bdd.totem.rayonCentre)/ratio,(position[1]+bdd.totem.rayonCentre)/ratio]
		self.canvasTerrain.create_oval( pos , fill="yellow",tags="totemBlue")
		pos=self.symetrie(pos)
		self.canvasTerrain.create_oval( pos , fill="yellow",tags="totemRed")
	
	def updateVitesse(self,event):
		self.Robot.vitesse=self.scaleVitesse.get()
	
	def runTrajectoire(self):
		self.desactivation()
		t=temps(self)
		t.start()
	
	def desactivation(self):
		self.boutonRunTrajectoire.config(state=DISABLED)
		self.boutonNewTrajectoire.config(state=DISABLED)
		self.boutonRetourAuDepart.config(state=DISABLED)
		
	def activation(self):
		self.boutonRunTrajectoire.config(state=NORMAL)
		self.boutonNewTrajectoire.config(state=NORMAL)
		self.boutonRetourAuDepart.config(state=NORMAL)
	
	def activerPilotage(self):
		self.ActionEnCours.set("Action en cours : pilotage au clavier")
		self.master.bind("<Left>", self.leftTouch)
		self.master.bind("<Right>", self.rightTouch)
		self.master.bind("<Up>", self.upTouch)
		self.master.bind("<Down>", self.downTouch)
		
	def desactiverPilotage(self):
		self.master.bind("<Left>", lambda e: None)
		self.master.bind("<Right>", lambda e: None)
		self.master.bind("<Up>", lambda e: None)
		self.master.bind("<Down>", lambda e: None)
	
	def newTrajectoire(self):
		self.canvasTerrain.delete("fleche")
		self.positionDepart()
		self.desactiverPilotage()
		self.listeAction.delete(0, END)
		self.ActionEnCours.set("Action en cours : creation de trajectoire, chaque clic cree un nouveau point , clic droit pour arreter")
		self.trajectoire=trajectoire.trajectoire()
		self.trajectoire.points.append(trajectoire.checkpoint((self.Robot.position[0],self.Robot.position[1])))
		self.canvasTerrain.bind("<Button-1>",self.newPoint)
		self.canvasTerrain.bind("<Button-3>",self.newTrajectoryEnd)
		
	
	def newTrajectoryEnd(self,event):
		self.canvasTerrain.bind("<Button-1>",lambda e: None)
		self.canvasTerrain.bind("<Button-3>",lambda e: None)
		self.canvasTerrain.delete("fleche")
		self.activerPilotage()
	
	def newPoint(self,event):
		self.trajectoire.points.append(trajectoire.checkpoint((event.x*ratio, event.y*ratio)))
		self.canvasTerrain.create_line(self.trajectoire.points[len(self.trajectoire.points)-2].position[0]/ratio,self.trajectoire.points[len(self.trajectoire.points)-2].position[1]/ratio,event.x, event.y,arrow=LAST,tags="fleche")
	
	def rightTouch(self,event):
		print "touche droite appuyee"
		self.Robot.orientation-=5
		self.updateRobot()
		
	def leftTouch(self,event):
		print "touche gauche appuyee"
		self.Robot.orientation+=5
		self.updateRobot()		
	
	def upTouch(self,event):
		print "touche haut appuyee"
		self.Robot.position[0]+=math.cos(self.Robot.orientation*math.pi/180)*5
		self.Robot.position[1]-=math.sin(self.Robot.orientation*math.pi/180)*5
		self.updateRobot()
		
	def downTouch(self,event):
		print "touche bas appuyee"
		self.Robot.position[0]-=math.cos(self.Robot.orientation*math.pi/180)*self.Robot.vitesse
		self.Robot.position[1]+=math.sin(self.Robot.orientation*math.pi/180)*self.Robot.vitesse
		self.updateRobot()
		
	def updateRobot(self):
		pause.wait()
		if self.Robot.orientation*math.pi/180 > math.pi :
			self.Robot.orientation -= 360
			
		if self.Robot.orientation*math.pi/180 < math.pi*(-1) :
			self.Robot.orientation += 360
			
		self.canvasTerrain.image = ImageTk.PhotoImage(self.Robot.img.rotate(self.Robot.orientation))
		self.canvasTerrain.coords(self.canvasRobot,self.Robot.position[0]/ratio,self.Robot.position[1]/ratio)
		self.canvasTerrain.itemconfig(self.canvasRobot,image=self.canvasTerrain.image)
